<script lang="ts">
  import { EventByPk$result, EventByPkStore } from '$houdini';
  import PageHeader from '$lib/components/layout/PageHeader.svelte';
  import Spinner from '$lib/components/ui-elements/Spinner.svelte';
  import { discordChannels } from '$lib/constants/urls';
  import CompetitionTimelineRow from '$routes/(app)/about/CompetitionTimelineRow.svelte';
  import CompetitionTimeline from '$routes/(app)/about/CompetitionTimeline.svelte';
  import Fa from 'svelte-fa';
  import {
    faArrowUpRightFromSquare,
    faCircleCheck,
    faGraduationCap,
    faPlayCircle,
    faQuestionCircle
  } from '@fortawesome/free-solid-svg-icons';
  import NextStepCard from '$routes/(app)/welcome-guide/[eventId]/NextStepCard.svelte';
  import HeaderWithBackdrop from '$lib/components/ui-elements/HeaderWithBackdrop.svelte';
  import { faTwitch } from '@fortawesome/free-brands-svg-icons';

  type PageData = {
    eventId: string;
  };

  /** @type {import('./$types').PageData} // Data from +page.ts */
  export let data: PageData;

  // todo handle invalid eventId without spinning forever
  $: eventStore = new EventByPkStore();
  $: eventStore.subscribe((result) => {
    if (result.errors?.length) console.error('failed fetch', result.errors);
  });
  let event: EventByPk$result['events_by_pk'];
  $: fetch(data.eventId);

  async function fetch(event_id: string) {
    await eventStore.fetch({ variables: { event_id } });
    if ($eventStore.data?.events_by_pk) event = $eventStore.data.events_by_pk;
  }

  function dateOffset(date: Date, days = 0, hours = 0, minutes = 0) {
    const ret = new Date(date.valueOf());
    ret.setHours(ret.getHours() + hours, ret.getMinutes() + minutes, 0, 0);
    ret.setDate(ret.getDate() + days);
    return ret;
  }

  function getQADay(date: Date) {
    let ret: Date;
    const exceptions: Record<string, Date> = {
      // Note: UTC months are 0 to 11, so 1 = Feb; 2 = March
      // Note: UTC days need to be advanced forward by 1 due to timezones
      "2025-02-15": new Date(Date.UTC(2025, 1, 14)),
      "2025-03-16": new Date(Date.UTC(2025, 2, 15)),
    }
    // Get the date in YYYY-MM-DD format to check for exceptions
    const key = date.toISOString().slice(0, 10);
    if (key in exceptions) {
      ret = new Date(exceptions[key].valueOf());
    } else {
      // Duplicate the date input so it can be modified
      ret = new Date(date.valueOf());
    }
    // Setting UTC hours on these start times will roll
    // the date back to the previous day.
    if (isDateNYDaylightSavings(ret)) {
      // When DST is in effect 0 is 8pm Eastern
      ret.setUTCHours(0);
    } else {
      // When no DST is in effect 1 is 8pm Eastern
      ret.setUTCHours(1);
    }
    return ret;
  }

  function formatDateTime(date: Date, separator = '<br>', tbd = false) {
    const hours = tbd ? "TBD" : date.toLocaleTimeString([], {
      hour: '2-digit',
      minute: '2-digit',
      timeZoneName: 'short'
    })
    return (
      date.toLocaleDateString('en-US', {
        weekday: 'short', // Display the day of the week
        day: 'numeric', // Display the date of the month
        month: 'short' // Display the month
      }) +
      separator + hours
    );
  }

  function isDateNYDaylightSavings(date: Date): boolean {
    const v = Intl.DateTimeFormat('en-US', {timeZone: "America/New_York", timeZoneName: "short",}).format(date).slice(-3)
    if (v == "EDT") {
      return true;
    }// else v == "EST"
    return false;
  }
</script>

{#if !event || $eventStore.fetching}
  <PageHeader title="Welcome..." />
  <div class="w-full h-64">
    <div class="self-center mx-auto my-auto">
      <Spinner />
    </div>
  </div>
{:else}
  <PageHeader title="Welcome to {event.name}" />
  <div class="mx-10 lg:mx-5 pb-16">
    <section class="text-cyber-blue-900 text-center p-8">
      <p class="text-xl leading-loose text-cyber-blue-900">
        Welcome to the event! Congratulations on registering for the
        <b>{event.event_group?.name} {event.name}</b> Competition! This is an incredible opportunity for you to get real-life
        experience while exploring different roles in cybersecurity. This guide will walk you through the process of completing
        your registration and preparing you for the competition.
      </p>
    </section>

    <HeaderWithBackdrop size="sm" secondary wrap>Competition Schedule</HeaderWithBackdrop>

    <section class="text-cyber-blue-900 text-center p-2">
      <div class="p-4 my-4 text-cyber-blue-800 rounded-lg bg-blue-50 lg:w-2/3 lg:mx-auto" role="alert">
        Be sure to allocate the entire day in your schedule for the competition.
        <b>The competition lasts for 7.5 hours, which includes a 1-hour lunch break/Q&A in the middle of the day</b>,
        and a 15-30 minute closing ceremony at the end of the day to discuss scores and feedback, and prizes!
      </div>
    </section>

    <CompetitionTimeline>
      <CompetitionTimelineRow>
        <span slot="time">
          {@html formatDateTime(getQADay(event.start), '<br>', false)}
        </span>
        <div slot="events">
          <p>Pre-Competition Live Q&A</p>
          <p>Exact time will be announced in Discord</p>
        </div>
        <p slot="description">
          Join us in the <b><a href={discordChannels.mainStage}>#main-stage</a></b>
          channel in Discord for a live pre-competition Question and Answer
          session with the NCAE Cyber Games Staff!
        </p>
      </CompetitionTimelineRow>
      <CompetitionTimelineRow>
        <span slot="time">
          {@html formatDateTime(dateOffset(event.start, 0, 0, -30))}
        </span>
        <div slot="events">Competition Platform is unlocked</div>
        <p slot="description">
          Test your team's access, and prepare for the games to begin! Reach out to staff members with any issues.
        </p>
      </CompetitionTimelineRow>
      <CompetitionTimelineRow>
        <span slot="time">{@html formatDateTime(event.start)}</span>
        <div slot="events">
          <p>Competition Begins</p>
          <p style="color:green;">Scoring Begins</p>
          <p style="color:green;">VMs / CTF Opened</p>
        </div>
        Check Discord and your welcome video for instructions on how to get started
        <p slot="description" />
      </CompetitionTimelineRow>
      <CompetitionTimelineRow>
        <span slot="time">{@html formatDateTime(dateOffset(event.start, 0, 3, 0))}</span>
        <div slot="events">
          <p>Lunch Break</p>
          <p style="color:red;">Scoring Stops</p>
          <p style="color:red;">VMs / CTF Closed</p>
        </div>
        <p slot="description">Eat the healthy lunch you packed and take a break!</p>
      </CompetitionTimelineRow>
      <CompetitionTimelineRow>
        <span slot="time">{@html formatDateTime(dateOffset(event.start, 0, 3, 30))}</span>
        <div slot="events">
          Lunchtime Live Q&A
        </div>
        <div slot="description">
          <p>
            Join us in the <b><a href={discordChannels.mainStage}>#main-stage</a></b>
            channel in Discord to ask questions and talk about how things are going so far.
          </p>
          <p>
            📢 We may have some important announcements! 📢
          </p>
        </div>
      </CompetitionTimelineRow>

      <CompetitionTimelineRow>
        <span slot="time">{@html formatDateTime(dateOffset(event.start, 0, 4, 0))}</span>
        <div slot="events">
          <p>Competition Resumes</p>
          <p style="color:green;">Scoring Resumes</p>
          <p style="color:green;">VMs / CTF Opened</p>
        </div>
      </CompetitionTimelineRow>
      <CompetitionTimelineRow>
        <span slot="time"> {@html formatDateTime(event.end)} </span>
        <div slot="events">
          <p>Competition Ends</p>
          <p style="color:red;">Scoring Ends</p>
          <p style="color:red;">VMs / CTF Closed</p>
          <p>Final Scores Calculated</p>
        </div>
        <div slot="description">
          Take a breather! Great job! There's only a few things for your team to prepare for the closing ceremony:
          <ul class="list-disc list-image-[url(/list-icon.svg)] text-left">
            <li>Take the competition survey and vote for your team's Most Valuable and Most Improved team member!</li>
            <li>Nominate a member of your team to speak on behalf of your team in the closing ceremony.</li>
            <li>Discuss how your day went with your team, we'll be asking your nominated member about it during the closing ceremony.</li>
          </ul>
        </div>
      </CompetitionTimelineRow>
      <CompetitionTimelineRow>
        <span slot="time">{@html formatDateTime(dateOffset(event.end, 0, 0, 15))}</span>
        <div slot="events">
          <p>Closing Ceremonies</p>
          <p>Round-table on team experiences</p>
          <p>Winning team announced</p>
        </div>
        <p slot="description">
          Hear some feedback from our team as well as other competitors. Share your experiences and get prizes!
        </p>
      </CompetitionTimelineRow>
    </CompetitionTimeline>

    <HeaderWithBackdrop size="sm" secondary wrap>Action Items</HeaderWithBackdrop>
    <section class="text-cyber-blue-900 text-center p-2">
      <div>
        <Fa class="inline-block text-green-500" icon={faCircleCheck} />
        <b>
          Finalize your team roster by:
          <span class="max-md:block">{formatDateTime(event.event_registration_setting?.roster_change_close, ' ')}</span>
        </b>
      </div>
      <div class="p-4 my-4 text-cyber-blue-800 rounded-lg bg-blue-50 lg:w-2/3 lg:mx-auto">
        If you need to add or remove members from your team, you may do so using the team management interface. You can
        make changes to your roster up to two days before your event. Make sure that all participating teams from your
        school are as even as possible.
      </div>
    </section>
    <section class="text-cyber-blue-900 text-center p-2">
      <div>
        <!-- todo dynamically check if the user and teammates (if captain) are linked to discord -->
        <!-- <Fa class="inline-block" color="red" icon={faCircleXmark} />-->
        <Fa class="inline-block text-green-500" icon={faCircleCheck} />
        <b>Setup and install discord</b>
      </div>
      <div class="p-4 my-4 text-cyber-blue-800 rounded-lg bg-blue-50 lg:w-2/3 lg:mx-auto">
        <p>
          Discord is a vital part of the competition environment: it's how the NCAE Staff will communicate with your
          team. Ensure that your entire team is able to access the NCAE Cyber Games Discord server before the
          competition begins.
        </p>
        <p>
          For more information about setting up Discord, please see our
          <a href="/discord-setup" target="_blank">Discord setup instructions</a>.
        </p>
      </div>
    </section>

    <HeaderWithBackdrop size="sm" secondary wrap>Next Steps</HeaderWithBackdrop>

    <!--    <div class="flex flex-col lg:flex-row gap-6 py-10">-->
    <div class="grid grid-cols-1 lg:grid-cols-3 gap-6 py-10">
      <NextStepCard icon={faGraduationCap}>
        <div slot="title">Practice and Train</div>
        <div slot="description">
          <p class="pb-4">
            Wondering what you'll be up against in the competition? There are challenges and workshops for your team to
            use to practice for the competition.
          </p>
          <p>
            The NCAE Cyber Games might be the <b>ONLY</b> competition with videos that walk you though EVERY skill you'll
            need to succeed in the event!
          </p>
        </div>
        <p slot="footer">
          Watch the <a href="/tutorials">Sandbox Tutorial Videos</a> and
          <a href="https://ui.sandbox.ncaecybergames.org/" target="_blank" class="inline-flex pb-4">
            jump into the Sandbox <Fa icon={faArrowUpRightFromSquare} class="mx-1" />
          </a>
          to unlock your success!
        </p>
      </NextStepCard>

      <NextStepCard icon={faTwitch}>
        <div slot="title">Twitch Live Streams</div>
        <div slot="description">
          <p class="pb-4">
            The NCAE Cyber Games hosts regular live streams to talk about the competition and walk through strategies,
            tips, tricks, and other valuable info related to the competition. Come hang out with us!
          </p>
        </div>

        <a slot="footer" href="https://www.twitch.tv/ncaecybergames" target="_blank" class="inline-flex">
          NCAE Cyber Games Twitch Channel
          <Fa icon={faArrowUpRightFromSquare} class="mx-1" />
        </a>
      </NextStepCard>

      <NextStepCard icon={faPlayCircle}>
        <div slot="title">Crack the CTFs, Meet the Players, and Much More!</div>
        <div slot="description">
          <p class="pb-4">
            There is a ton of content available to introduce your team to the competition and help you prepare. Get an
            inside look directly from the creators of the challenges, and meet other players who have been successful
            with the competition!
          </p>
        </div>
        <a slot="footer" href="/about/media" target="_blank"> NCAE Cyber Games Media </a>
      </NextStepCard>

      <NextStepCard class="lg:col-start-2" icon={faQuestionCircle}>
        <div slot="title">Need Help?</div>
        <div slot="description">
          <p class="pb-4">
            The best way to get help is in the Discord <a href={discordChannels.help} target="_blank">#help</a>
            channel. You can also contact us over email from our support page:
          </p>
          <a href="/support" target="_blank" class="inline-flex pb-4"> Contact Support </a>
        </div>
      </NextStepCard>
    </div>
  </div>
{/if}
